## julia 0.1+dfsg

=== Makefile ===
JULIAHOME = $(abspath .)
include $(JULIAHOME)/Make.inc

all: default
default: release

DIRS = $(BUILD)/bin $(BUILD)/lib $(BUILD)/$(JL_PRIVATE_LIBDIR) $(BUILD)/share/julia

$(foreach dir,$(DIRS),$(eval $(call dir_target,$(dir))))
$(foreach link,extras base test doc examples ui,$(eval $(call symlink_target,$(link),$(BUILD)/share/julia)))

QUIET_MAKE =
ifeq ($(USE_QUIET), 1)
QUIET_MAKE = -s
endif

debug release: | $(DIRS) $(BUILD)/share/julia/extras $(BUILD)/share/julia/base $(BUILD)/share/julia/test $(BUILD)/share/julia/doc $(BUILD)/share/julia/examples $(BUILD)/share/julia/ui
	@$(MAKE) $(QUIET_MAKE) julia-$@
	@export JL_PRIVATE_LIBDIR=$(JL_PRIVATE_LIBDIR) && \
	$(MAKE) $(QUIET_MAKE) LD_LIBRARY_PATH=$(BUILD)/lib:$(LD_LIBRARY_PATH) JULIA_EXECUTABLE="$(JULIA_EXECUTABLE_$@)" $(BUILD)/$(JL_PRIVATE_LIBDIR)/sys.ji

julia-debug julia-release:
	@-git submodule init --quiet
	@-git submodule update
	@$(MAKE) $(QUIET_MAKE) -C deps
	@$(MAKE) $(QUIET_MAKE) -C src lib$@
	@$(MAKE) $(QUIET_MAKE) -C base
	@$(MAKE) $(QUIET_MAKE) -C extras
	@$(MAKE) $(QUIET_MAKE) -C ui $@
	@ln -sf $(BUILD)/bin/$@-$(DEFAULT_REPL) julia

$(BUILD)/share/julia/helpdb.jl: doc/helpdb.jl | $(BUILD)/share/julia
	@cp $< $@

# use sys.ji if it exists, otherwise run two stages
$(BUILD)/$(JL_PRIVATE_LIBDIR)/sys.ji: VERSION base/*.jl base/pkg/*.jl $(BUILD)/share/julia/helpdb.jl
	@#echo `git rev-parse --short HEAD`-$(OS)-$(ARCH) \(`date +"%Y-%m-%d %H:%M:%S"`\) > COMMIT
	$(QUIET_JULIA) cd base && \
	(test -f $(BUILD)/$(JL_PRIVATE_LIBDIR)/sys.ji || $(JULIA_EXECUTABLE) -bf sysimg.jl) && $(JULIA_EXECUTABLE) -f sysimg.jl || echo "Note: this error is usually fixed by running 'make clean'. If the error persists, 'make cleanall' may help."

run-julia-debug run-julia-release: run-julia-%:
	$(MAKE) $(QUIET_MAKE) run-julia JULIA_EXECUTABLE="$(JULIA_EXECUTABLE_$*)"
run-julia:
	#winedbg --gdb
	$(JULIA_EXECUTABLE)

# public libraries, that are installed in $(PREFIX)/lib
JL_LIBS = julia-release julia-debug

# private libraries, that are installed in $(PREFIX)/lib/julia
JL_PRIVATE_LIBS = amd arpack cholmod colamd fftw3 fftw3f fftw3_threads \
                  fftw3f_threads gmp grisu \
                  openlibm openlibm-extras pcre \
		  random Rmath spqr suitesparse_wrapper \
		  tk_wrapper umfpack z openblas

PREFIX ?= julia-$(JULIA_COMMIT)
install: release webrepl
	@-$(MAKE) $(QUIET_MAKE) tk
	@for subdir in "sbin" "bin" "etc" $(JL_LIBDIR) $(JL_PRIVATE_LIBDIR) "share/julia" ; do \
		mkdir -p $(PREFIX)/$$subdir ; \
	done
	cp $(BUILD)/bin/*julia* $(PREFIX)/bin
	cd $(PREFIX)/bin && ln -sf julia-release-$(DEFAULT_REPL) julia
	-for suffix in $(JL_LIBS) ; do \
		cp -a $(BUILD)/$(JL_LIBDIR)/lib$${suffix}*.$(SHLIB_EXT)* $(PREFIX)/$(JL_PRIVATE_LIBDIR) ; \
	done
	-for suffix in $(JL_PRIVATE_LIBS) ; do \
		cp -a $(BUILD)/lib/lib$${suffix}*.$(SHLIB_EXT)* $(PREFIX)/$(JL_PRIVATE_LIBDIR) ; \
	done
	# Copy system image
	cp $(BUILD)/$(JL_PRIVATE_LIBDIR)/sys.ji $(PREFIX)/$(JL_PRIVATE_LIBDIR)
	# Copy in all .jl sources as well
	-cp -R -L $(BUILD)/share/julia $(PREFIX)/share/
	-cp $(BUILD)/etc/nginx.conf $(PREFIX)/etc/
ifeq ($(OS), WINNT)
	-cp $(JULIAHOME)/contrib/windows/* $(PREFIX)
	-cp -R $(BUILD)/sbin $(PREFIX)
	-[ -e dist-extras/7za.exe ] && cp dist-extras/7za.exe $(PREFIX)/bin/7z.exe
	-[ -e dist-extras/PortableGit-1.8.0-preview20121022.7z ] && \
	  mkdir $(PREFIX)/Git && \
	  7z x dist-extras/PortableGit-1.8.0-preview20121022.7z -o"$(PREFIX)/Git"
ifeq ($(shell uname),MINGW32_NT-6.1)
	-for dllname in "libgfortran-3" "libquadmath-0" "libgcc_s_dw2-1" "libstdc++-6,pthreadgc2" ; do \
		cp /mingw/bin/$${dllname}.dll $(PREFIX)/$(JL_LIBDIR) ; \
	done
else
	-for dllname in "libgfortran-3" "libquadmath-0" "libgcc_s_sjlj-1" "libstdc++-6" ; do \
		cp /usr/lib/gcc/i686-w64-mingw32/4.6/$${dllname}.dll $(PREFIX)/$(JL_LIBDIR) ; \
	done
endif
endif
	cp $(JULIAHOME)/VERSION $(PREFIX)/share/julia/VERSION
	echo `git rev-parse --short HEAD`-$(OS)-$(ARCH) \(`date +"%Y-%m-%d %H:%M:%S"`\) > $(PREFIX)/share/julia/COMMIT

dist: 
	rm -fr julia-*.tar.gz julia-$(JULIA_COMMIT)
#	-$(MAKE) -C deps clean-openblas
	$(MAKE) install OPENBLAS_DYNAMIC_ARCH=1
ifeq ($(OS), Darwin)
	-./contrib/fixup-libgfortran.sh $(PREFIX)/$(JL_PRIVATE_LIBDIR)
endif
ifeq ($(OS), WINNT)
	zip -r -9 julia-$(JULIA_COMMIT)-$(OS)-$(ARCH).zip julia-$(JULIA_COMMIT)
else
	tar zcvf julia-$(JULIA_COMMIT)-$(OS)-$(ARCH).tar.gz julia-$(JULIA_COMMIT)
endif
	rm -fr julia-$(JULIA_COMMIT)

clean: | $(CLEAN_TARGETS)
	@$(MAKE) -C base clean
	@$(MAKE) -C extras clean
	@$(MAKE) -C src clean
	@$(MAKE) -C ui clean
	@for buildtype in "release" "debug" ; do \
		for repltype in "basic" "readline"; do \
			rm -f julia-$${buildtype}-$${repltype}; \
		done \
	done
	@rm -f julia
	@rm -f *~ *# *.tar.gz
	@rm -fr $(BUILD)/$(JL_PRIVATE_LIBDIR)

cleanall: clean
	@$(MAKE) -C src clean-flisp clean-support
	@rm -fr $(BUILD)/$(JL_LIBDIR)
#	@$(MAKE) -C deps clean-uv

.PHONY: default debug release julia-debug julia-release \
	test testall test-* clean cleanall webrepl \
	run-julia run-julia-debug run-julia-release

test: release
	@$(MAKE) $(QUIET_MAKE) -C test default

testall: release
	@$(MAKE) $(QUIET_MAKE) -C test all

test-%: release
	@$(MAKE) $(QUIET_MAKE) -C test $*

webrepl: all
ifeq ($(USE_SYSTEM_NGINX), 0)
	@$(MAKE) $(QUIET_MAKE) -C deps install-nginx
endif
	@$(MAKE) -C ui/webserver julia-release

tk:
	@$(MAKE) -C deps install-tk-wrapper

# download target for some hardcoded windows dependencies
.PHONY: win-extras
win-extras:
	cd dist-extras && \
	wget http://downloads.sourceforge.net/sevenzip/7za920.zip && \
	wget https://msysgit.googlecode.com/files/PortableGit-1.8.0-preview20121022.7z

=== deps/Makefile ===
include Versions.make

## optional packages and options #
LLVM_ASSERTIONS = 0
# set to 1 to get clang and compiler-rt
BUILD_LLVM_CLANG = 0
# set to 1 to get lldb (does not work with llvm3.1 and earlier)
# see http://lldb.llvm.org/build.html for dependancies
BUILD_LLDB = 0

## high-level setup ##

JULIAHOME = $(abspath ..)
include $(JULIAHOME)/Make.inc
CONFIGURE_COMMON = --prefix=$(abspath $(BUILD)) F77="$(FC)" CC="$(CC)" CXX="$(CXX)"
ifneq ($(XC_HOST),)
CONFIG_GUESS := $(shell ./config.guess)
CONFIGURE_COMMON += --host=$(XC_HOST) --build=$(CONFIG_GUESS)
endif

#autoconf configure-driven scripts: llvm readline pcre arpack fftw unwind gmp patchelf
#custom configure-driven script: zlib nginx
#custom Makefile rules: openlibm Rmath double-conversion random suitesparse-wrapper suitesparse lapack openblas uv tk-wrapper

# prevent installing libs into usr/lib64 on opensuse
unexport CONFIG_SITE

STAGE1_DEPS = uv openlibm-extras random Rmath double-conversion
STAGE2_DEPS =
STAGE3_DEPS = suitesparse-wrapper

ifeq ($(USE_SYSTEM_LIBUNWIND), 0)
ifeq ($(OS), Linux)
STAGE1_DEPS += unwind
else ifeq ($(OS), FreeBSD)
STAGE1_DEPS += unwind
endif
endif

ifeq ($(OS), Linux)
STAGE1_DEPS += patchelf
endif

WGET = $(abspath .)/jldownload
WGET_DASH_O = $(WGET)

## USE_SYSTEM_LIBS options

ifeq ($(USE_SYSTEM_LIBM), 0)
STAGE1_DEPS += openlibm
endif

ifeq ($(USE_SYSTEM_LLVM), 0)
STAGE1_DEPS += llvm
endif

ifeq ($(OS),WINNT)
READLINE_VER = 5.0
endif

ifeq ($(USE_SYSTEM_READLINE), 0)
STAGE1_DEPS += readline
endif

ifeq ($(USE_SYSTEM_PCRE), 0)
STAGE1_DEPS += pcre
endif

ifeq ($(USE_SYSTEM_BLAS), 0)
STAGE1_DEPS += openblas
endif

ifeq ($(USE_SYSTEM_FFTW), 0)
STAGE1_DEPS += fftw
endif

ifeq ($(USE_SYSTEM_GMP), 0)
STAGE1_DEPS += gmp
endif

ifeq ($(USE_SYSTEM_ZLIB), 0)
STAGE1_DEPS += zlib
endif

ifeq ($(USE_SYSTEM_ARPACK), 0)
STAGE2_DEPS += arpack
endif

ifeq ($(USE_SYSTEM_SUITESPARSE), 0)
STAGE2_DEPS += suitesparse
endif

#ifeq ($(USE_SYSTEM_LAPACK), 0)
#STAGE2_DEPS += lapack
#endif

#Platform specific flags

ifeq ($(OS), WINNT)
LIBTOOL_CCLD = CCLD="$(CC) -no-undefined -avoid-version"
AUTOTOOLS_PATH_CORRECT = -cp -f $(BUILD)/bin/$(@F) $(BUILD)/lib/$(@F)
endif

## Common build target prefixes

LIBS = $(STAGE1_DEPS) $(STAGE2_DEPS) $(STAGE3_DEPS)

default: $(BUILD) install
get: $(addprefix get-, $(LIBS))
configure: $(addprefix configure-, $(LIBS))
compile: $(addprefix compile-, $(LIBS))
check: $(addprefix check-, $(LIBS))
install: $(addprefix install-, $(LIBS))
cleanall: $(addprefix clean-, $(LIBS))
distclean: $(addprefix distclean-, $(LIBS))
	rm -rf $(BUILD)
getall: get-llvm get-readline get-uv get-pcre get-double-conversion get-openlibm get-random get-openblas get-fftw get-suitesparse get-clp get-unwind get-nginx get-gmp get-zlib get-patchelf

## PATHS ##
DIRS = $(addprefix $(BUILD)/,lib include bin share etc)

$(foreach dir,$(DIRS),$(eval $(call dir_target,$(dir))))

$(BUILD): $(DIRS)

## LLVM ##
ifeq ($(BUILD_LLDB), 1)
BUILD_LLVM_CLANG = 1
# because it's a build requirement
endif

ifeq ($(LLVM_ASSERTIONS), 1)
LLVM_BUILDDIR = build/Release+Asserts
else
LLVM_BUILDDIR = build/Release
endif

ifeq ($(OS),WINNT)
LLVM_LIB_FILE = LLVM-$(LLVM_VER)$(LLVM_LIB_SUFFIX).$(SHLIB_EXT)
LLVM_OBJ_SOURCE = llvm-$(LLVM_VER)/$(LLVM_BUILDDIR)/bin/$(LLVM_LIB_FILE)
else
LLVM_LIB_FILE = libLLVM-$(LLVM_VER)$(LLVM_LIB_SUFFIX).$(SHLIB_EXT)
LLVM_OBJ_SOURCE = llvm-$(LLVM_VER)/$(LLVM_BUILDDIR)/lib/$(LLVM_LIB_FILE)
endif
LLVM_OBJ_TARGET = $(BUILD)/lib/$(LLVM_LIB_FILE)


ifeq ($(LLVM_VER), 3.0)
LLVM_TAR=llvm-$(LLVM_VER).tar.gz
else
LLVM_TAR=llvm-$(LLVM_VER).src.tar.gz
endif

ifeq ($(BUILD_LLVM_CLANG),1)
ifeq ($(LLVM_VER), 3.0)
LLVM_CLANG_TAR=clang-$(LLVM_VER).tar.gz
LLVM_COMPILER_RT_TAR=
else
LLVM_CLANG_TAR=clang-$(LLVM_VER).src.tar.gz
LLVM_COMPILER_RT_TAR=compiler-rt-$(LLVM_VER).src.tar.gz
endif
else
LLVM_CLANG_TAR=
LLVM_COMPILER_RT_TAR=
endif

LLVM_FLAGS =  --disable-threads --disable-profiling --enable-shared --enable-targets=host --disable-bindings --disable-docs
LLVM_MFLAGS =
ifeq ($(LLVM_ASSERTIONS), 1)
LLVM_FLAGS += --enable-assertions --enable-optimized
ifeq ($(OS), WINNT)
LLVM_FLAGS += --disable-embed-stdcxx
endif
else
LLVM_FLAGS += --disable-assertions --enable-optimized
endif

ifeq ($(BUILD_LLDB),1)
ifeq ($(USECLANG),1)
LLVM_FLAGS += --enable-cxx11
else
LLVM_MFLAGS += CXXFLAGS=-std=c++0x
endif
endif

ifeq ($(ARCH), ppc64)
  LLVM_FLAGS += CXXFLAGS=-mminimal-toc
  LLVM_MFLAGS += CXXFLAGS=-mminimal-toc
endif

ifneq ($(LLVM_CLANG_TAR),)
$(LLVM_CLANG_TAR):
	$(WGET) http://llvm.org/releases/$(LLVM_VER)/$@
endif
ifneq ($(LLVM_COMPILER_RT_TAR),)
$(LLVM_COMPILER_RT_TAR):
	$(WGET) http://llvm.org/releases/$(LLVM_VER)/$@
endif
$(LLVM_TAR):
	$(WGET) http://llvm.org/releases/$(LLVM_VER)/$@

ifeq ($(BUILD_LLDB),1)
llvm-$(LLVM_VER)/tools/lldb:
llvm-$(LLVM_VER)/configure: llvm-$(LLVM_VER)/tools/lldb
endif

## LLVM needs python 2.x, but doesn't check for it, so we have to use an ugly workaround to make it compile
llvm-$(LLVM_VER)/python2_path:
	mkdir -p llvm-$(LLVM_VER)/python2_path
	-python -c 'import sys; sys.exit(not sys.version_info > (3, 0))' && \
	/usr/bin/python2 -c 'import sys; sys.exit(not sys.version_info < (3, 0))' && \
	ln -sf /usr/bin/python2 "llvm-$(LLVM_VER)/python2_path/python"
llvm_python_workaround=llvm-$(LLVM_VER)/python2_path

llvm-$(LLVM_VER)/configure: $(LLVM_TAR) $(LLVM_CLANG_TAR) $(LLVM_COMPILER_RT_TAR)
	mkdir -p llvm-$(LLVM_VER) && \
	tar -C llvm-$(LLVM_VER) --strip-components 1 -xf $(LLVM_TAR)
ifneq ($(LLVM_CLANG_TAR),)
	mkdir -p llvm-$(LLVM_VER)/tools/clang && \
	tar -C llvm-$(LLVM_VER)/tools/clang --strip-components 1 -xf $(LLVM_CLANG_TAR)
endif
ifneq ($(LLVM_COMPILER_RT_TAR),)
	mkdir -p llvm-$(LLVM_VER)/projects/compiler-rt && \
	tar -C llvm-$(LLVM_VER)/projects/compiler-rt --strip-components 1 -xf $(LLVM_COMPILER_RT_TAR)
endif
ifeq ($(BUILD_LLDB), 1)
	([ ! -d llvm-$(LLVM_VER)/tools/lldb ] && \
		(cd llvm-$(LLVM_VER)/tools && \
		git clone http://llvm.org/git/lldb.git)) || \
	([ -d llvm-$(LLVM_VER)/tools/lldb ] && \
		(cd llvm-$(LLVM_VER)/tools/lldb && \
		git fetch))
	cd llvm-$(LLVM_VER)/tools/lldb && git checkout origin/release_32
endif
	touch -c $@

llvm-$(LLVM_VER)/build/config.status: llvm-$(LLVM_VER)/configure | $(llvm_python_workaround)
	cd llvm-$(LLVM_VER) && \
	mkdir -p build && cd build && \
	export PATH=$(abspath llvm-$(LLVM_VER)/python2_path):$$PATH && \
	../configure $(CONFIGURE_COMMON) $(LLVM_FLAGS)
	touch -c $@
$(LLVM_OBJ_SOURCE): llvm-$(LLVM_VER)/build/config.status | $(llvm_python_workaround)
	cd llvm-$(LLVM_VER)/build && \
	export PATH=$(abspath llvm-$(LLVM_VER)/python2_path):$$PATH && \
	$(MAKE) $(LLVM_MFLAGS)
	touch -c $@
llvm-$(LLVM_VER)/build/checked: $(LLVM_OBJ_SOURCE) | $(llvm_python_workaround)
ifeq ($(OS),$(BUILD_OS))
	cd llvm-$(LLVM_VER)/build && \
	export PATH=$(abspath llvm-$(LLVM_VER)/python2_path):$$PATH && \
	$(MAKE) $(LLVM_MFLAGS) check 
endif
	echo 1 > $@
$(LLVM_OBJ_TARGET): $(LLVM_OBJ_SOURCE) | $(llvm_python_workaround)
	export PATH=$(abspath llvm-$(LLVM_VER)/python2_path):$$PATH && \
	$(MAKE) -C llvm-$(LLVM_VER)/build install
	$(INSTALL_NAME_CMD)$(LLVM_LIB_FILE) $(BUILD)/lib/$(LLVM_LIB_FILE)
	$(AUTOTOOLS_PATH_CORRECT) 
	touch -c $@

clean-llvm:
	-$(MAKE) -C llvm-$(LLVM_VER)/build clean
	-rm -f $(BUILD)/bin/llvm-config
distclean-llvm:
	-rm -rf llvm-$(LLVM_VER).tar.gz llvm-$(LLVM_VER).src.tar.gz clang-$(LLVM_VER).src.tar.gz clang-$(LLVM_VER).tar.gz compiler-rt-$(LLVM_VER).src.tar.gz llvm-$(LLVM_VER)

get-llvm: $(LLVM_TAR) $(LLVM_CLANG_TAR) $(LLVM_COMPILER_RT_TAR)
configure-llvm: llvm-$(LLVM_VER)/build/config.status
compile-llvm: $(LLVM_OBJ_SOURCE)
check-llvm: llvm-$(LLVM_VER)/build/checked
install-llvm: $(LLVM_OBJ_TARGET)
#todo: LLVM make check target is broken on julia.mit.edu (and really slow elsewhere)


## GNU readline ##


ifeq ($(OS),WINNT)
READLINE_OBJ_TARGET = $(BUILD)/lib/libreadline.a
READLINE_OBJ_SOURCE = readline-$(READLINE_VER)/libreadline.a
READLINE_URL = https://github.com/JuliaLang/readline/tarball/master
READLINE_OPTS = --disable-shared --enable-static --with-curses
READLINE_CFLAGS = LOCAL_DEFS="-include $(abspath .)/readline-win.h"
readline-$(READLINE_VER).tar.gz:
	$(WGET_DASH_O) $@ $(READLINE_URL)
	touch -c $@
readline-$(READLINE_VER)/configure: readline-$(READLINE_VER).tar.gz
	mkdir readline-$(READLINE_VER)
	tar -C readline-$(READLINE_VER) --strip-components 1 -xf $<
	touch -c $@
$(READLINE_OBJ_TARGET): $(READLINE_OBJ_SOURCE) readline-$(READLINE_VER)/checked
	$(MAKE) -C readline-$(READLINE_VER) $(READLINE_CFLAGS) install
	touch -c $@
else
READLINE_OBJ_TARGET = $(BUILD)/lib/libreadline.$(SHLIB_EXT)
ifneq ($(OS),Darwin)
READLINE_OBJ_SOURCE = readline-$(READLINE_VER)/shlib/libreadline.$(SHLIB_EXT).$(READLINE_VER)
else
READLINE_OBJ_SOURCE = readline-$(READLINE_VER)/shlib/libreadline.$(READLINE_VER).$(SHLIB_EXT)
endif
READLINE_URL = ftp://ftp.gnu.org/gnu/readline/readline-$(READLINE_VER).tar.gz
READLINE_OPTS = --enable-shared --enable-static --with-curses
READLINE_CFLAGS = 
readline-$(READLINE_VER).tar.gz:
	$(WGET) http://ftp.gnu.org/gnu/readline/readline-6.2-patches/readline62-001
	$(WGET) http://ftp.gnu.org/gnu/readline/readline-6.2-patches/readline62-002
	$(WGET) http://ftp.gnu.org/gnu/readline/readline-6.2-patches/readline62-003
	$(WGET) http://ftp.gnu.org/gnu/readline/readline-6.2-patches/readline62-004
	$(WGET) http://ftp.gnu.org/gnu/readline/$@
	touch -c $@
readline-$(READLINE_VER)/configure: readline-$(READLINE_VER).tar.gz
	tar zxf $<
	cd readline-$(READLINE_VER) && patch -p0 < ../readline62-001
	cd readline-$(READLINE_VER) && patch -p0 < ../readline62-002
	cd readline-$(READLINE_VER) && patch -p0 < ../readline62-003
	cd readline-$(READLINE_VER) && patch -p0 < ../readline62-004
	touch -c $@
$(READLINE_OBJ_TARGET): $(READLINE_OBJ_SOURCE) readline-$(READLINE_VER)/checked
	$(MAKE) -C readline-$(READLINE_VER) install
	chmod +w $(BUILD)/lib/libreadline.* $(BUILD)/lib/libhistory.*
ifeq ($(OS), Darwin)
	$(INSTALL_NAME_CMD)libreadline.$(SHLIB_EXT) $(BUILD)/lib/libreadline.$(SHLIB_EXT)
	$(INSTALL_NAME_CMD)libhistory.dylib $(BUILD)/lib/libhistory.dylib
else ifeq ($(OS), Linux)
	for filename in $(BUILD)/lib/libhistory.so* $(BUILD)/lib/libreadline.so* ; do \
		$(BUILD)/bin/patchelf --set-rpath '$$ORIGIN' $$filename ;\
	done
endif
	touch -c $@
endif

readline-$(READLINE_VER)/config.status: readline-$(READLINE_VER)/configure
	cd readline-$(READLINE_VER) && \
	chmod a+x ./configure && \
	./configure $(CONFIGURE_COMMON) $(READLINE_OPTS)
	touch -c $@
$(READLINE_OBJ_SOURCE): readline-$(READLINE_VER)/config.status
	cd readline-$(READLINE_VER) && \
	$(MAKE) $(READLINE_CFLAGS)
	touch -c $@
readline-$(READLINE_VER)/checked: $(READLINE_OBJ_SOURCE)
	cd readline-$(READLINE_VER) && \
	$(MAKE) check $(READLINE_CFLAGS)
	echo 1 > $@

clean-readline:
	-$(MAKE) -C readline-$(READLINE_VER) clean
	-rm -f $(READLINE_OBJ_TARGET)
distclean-readline:
	-rm -rf readline-$(READLINE_VER).tar.gz readline-$(READLINE_VER)

get-readline: readline-$(READLINE_VER).tar.gz
configure-readline: readline-$(READLINE_VER)/config.status
compile-readline: $(READLINE_OBJ_SOURCE)
check-readline: readline-$(READLINE_VER)/checked
install-readline: $(READLINE_OBJ_TARGET) 


## LIBUV ##

uname_S=$(OS)
ifeq ($(uname_S),WINNT)
uname_S=MINGW
endif

UV_OBJ_TARGET = $(BUILD)/lib/libuv.a
UV_OBJ_SOURCE = libuv/libuv.a

libuv/Makefile:
	(cd .. && git submodule init && git submodule update)
ifeq (exists, $(shell [ -d libuv/.git ] && echo exists ))
$(UV_OBJ_SOURCE): libuv/.git/HEAD
endif
ifeq (exists, $(shell [ -d $(JULIAHOME)/modules ] && echo exists ))
$(UV_OBJ_SOURCE): $(JULIAHOME)/.git/modules/deps/libuv/HEAD
endif
LIBUV_MAKE_FLAGS = -C libuv CC="$(CC)" AR="$(AR)" uname_S=$(uname_S)
$(UV_OBJ_SOURCE): libuv/Makefile
ifneq ($(OS), WINNT)
	$(MAKE) libuv.${SHLIB_EXT} $(LIBUV_MAKE_FLAGS)
endif
	$(MAKE) libuv.a $(LIBUV_MAKE_FLAGS)
	touch -c $@
libuv/checked: $(LIBUV_OBJ_SOURCE)
ifeq ($(OS),$(BUILD_OS))
	$(MAKE) test $(LIBUV_MAKE_FLAGS)
endif
	echo 1 > $@
#todo: libuv tests are really slow
$(UV_OBJ_TARGET): $(UV_OBJ_SOURCE)

=== src/Makefile ===
JULIAHOME = $(abspath ..)
include $(JULIAHOME)/Make.inc

override CFLAGS += $(JCFLAGS)
override CXXFLAGS += $(JCXXFLAGS)

SRCS = \
	jltypes gf ast builtins module codegen interpreter \
	alloc dlload sys init task array dump toplevel wrapper

FLAGS = \
	-D_GNU_SOURCE \
	-Wall -Wno-strict-aliasing -fno-omit-frame-pointer \
	-Iflisp -Isupport -fvisibility=hidden -fno-common \
	-I$(shell $(LLVM_CONFIG) --includedir) \
	-I$(JULIAHOME)/deps/libuv/include -I$(JULIAHOME)/usr/include

LIBS = $(WHOLE_ARCHIVE) $(JULIAHOME)/src/flisp/libflisp.a $(WHOLE_ARCHIVE) $(JULIAHOME)/src/support/libsupport.a -L$(BUILD)/lib $(BUILD)/lib/libuv.a $(shell $(LLVM_CONFIG) --libs) $(NO_WHOLE_ARCHIVE) $(shell $(LLVM_CONFIG) --ldflags) $(OSLIBS)

ifneq ($(MAKECMDGOALS),debug)
TARGET =
else
TARGET = "debug"
endif

OBJS = $(SRCS:%=%.o)
DOBJS = $(SRCS:%=%.do)
DEBUGFLAGS += $(FLAGS)
SHIPFLAGS += $(FLAGS)

ifeq ($(JULIAGC),MARKSWEEP)
SRCS += gc
endif

ifeq ($(USE_COPY_STACKS),1)
JCFLAGS += -DCOPY_STACKS
endif

default: release

release debug: %: libjulia-%

HEADERS = julia.h $(wildcard support/*.h) $(JULIAHOME)/deps/libuv/include/uv.h

%.o: %.c $(HEADERS)
	$(QUIET_CC) $(CC) $(CPPFLAGS) $(CFLAGS) $(SHIPFLAGS) -c $< -o $@
%.do: %.c $(HEADERS)
	$(QUIET_CC) $(CC) $(CPPFLAGS) $(CFLAGS) $(DEBUGFLAGS) -c $< -o $@
%.o: %.cpp $(HEADERS)
	$(QUIET_CC) $(CXX) $(CPPFLAGS) $(CXXFLAGS) $(SHIPFLAGS) $(shell $(LLVM_CONFIG) --cppflags) -c $< -o $@
%.do: %.cpp $(HEADERS)
	$(QUIET_CC) $(CXX) $(CPPFLAGS) $(CXXFLAGS) $(DEBUGFLAGS) $(shell $(LLVM_CONFIG) --cppflags) -c $< -o $@

ast.o ast.do: julia_flisp.boot.inc flisp/*.h

julia_flisp.boot.inc: julia_flisp.boot flisp/libflisp.a
	$(QUIET_FLISP) ./flisp/flisp ./bin2hex.scm < $< > $@

julia_flisp.boot: julia-parser.scm julia-syntax.scm \
	match.scm utils.scm jlfrontend.scm mk_julia_flisp_boot.scm flisp/libflisp.a
	$(QUIET_FLISP) ./flisp/flisp ./mk_julia_flisp_boot.scm

codegen.o codegen.do: intrinsics.cpp debuginfo.cpp cgutils.cpp ccall.cpp
builtins.o builtins.do: table.c

support/libsupport.a: support/*.h support/*.c
	$(MAKE) -C support $(TARGET)

flisp/libflisp.a: flisp/*.h flisp/*.c support/libsupport.a
	$(MAKE) -C flisp

$(BUILD)/$(JL_LIBDIR)/libjulia-debug.$(SHLIB_EXT): julia.expmap $(DOBJS) flisp/libflisp.a support/libsupport.a $(BUILD)/lib/libuv.a
	$(QUIET_LINK) $(CXX) $(DEBUGFLAGS) $(DOBJS) $(RPATH_ORIGIN) -shared -o $@ $(LDFLAGS) $(LIBS)
	$(INSTALL_NAME_CMD)libjulia-debug.$(SHLIB_EXT) $@
libjulia-debug.a: julia.expmap $(DOBJS) flisp/libflisp.a support/libsupport.a
	rm -f $@
	$(QUIET_LINK) ar -rcs $@ $(DOBJS)
libjulia-debug: $(BUILD)/$(JL_LIBDIR)/libjulia-debug.$(SHLIB_EXT)

ifeq ($(SHLIB_EXT), so)
  SONAME = -Wl,-soname=libjulia-release.so
else
  SONAME =
endif

$(BUILD)/$(JL_LIBDIR)/libjulia-release.$(SHLIB_EXT): julia.expmap $(OBJS) flisp/libflisp.a support/libsupport.a $(BUILD)/lib/libuv.a
	$(QUIET_LINK) $(CXX) $(SHIPFLAGS) $(OBJS) $(RPATH_ORIGIN) -shared -o $@ $(LDFLAGS) $(LIBS) $(SONAME)
	$(INSTALL_NAME_CMD)libjulia-release.$(SHLIB_EXT) $@
libjulia-release.a: julia.expmap $(OBJS) flisp/libflisp.a support/libsupport.a
	rm -f $@
	$(QUIET_LINK) ar -rcs $@ $(OBJS)
libjulia-release: $(BUILD)/$(JL_LIBDIR)/libjulia-release.$(SHLIB_EXT)

clean:
	-rm -f $(BUILD)/$(JL_LIBDIR)/libjulia*
	-rm -f julia_flisp.boot julia_flisp.boot.inc
	-rm -f *.do *.o *~ *# *.$(SHLIB_EXT) *.a h2j

clean-flisp:
	-$(MAKE) -C flisp clean

clean-support:
	-$(MAKE) -C support clean

cleanall: clean clean-flisp clean-support

.PHONY: debug release clean cleanall clean-*


h2j: h2j.cpp
	$(QUIET_CC) $(CXX) $(CFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(DEBUGFLAGS) $(shell $(LLVM_CONFIG) --cppflags) $< -o $@ \
		-lclangFrontendTool -lclangBasic -lclangLex -lclangDriver -lclangFrontend -lclangParse \
		-lclangAST -lclangSema -lclangAnalysis -lclangEdit \
		-lclangRewrite -lclangSerialization -lclangStaticAnalyzerCheckers \
		-lclangStaticAnalyzerCore -lclangStaticAnalyzerFrontend -lclangTooling \
		-lclangCodeGen -lclangARCMigrate -lclang  $(LIBS) $(LDFLAGS)

=== test/Makefile ===
JULIAHOME = $(abspath ..)
include ../Make.inc

default all extra unicode gzip::

TESTS = default all extra \
core numbers strings unicode corelib hashing remote \
arrayops blas linalg fft dct sparse bitarray suitesparse arpack \
random math functional bigint bigfloat sorting \
statistics poly file Rmath remote zlib image \
iostring gzip integers spawn ccall parallel

$(TESTS) ::
	$(QUIET_JULIA) $(JULIA_EXECUTABLE) ./runtests.jl $@

perf:
ifneq ($(MAKECMDGOALS),perf)
	$(QUIET_JULIA) $(JULIA_EXECUTABLE) perf/$@.jl
else
	@$(JULIA_EXECUTABLE) perf/$@.jl | perl -nle '@_=split/,/; printf "%-14s %7.3f\n", $$_[1], $$_[2]'
endif

benchmark:
	@$(MAKE) -C perf $@

clean:
	@$(MAKE) -C perf $@
	-rm -f libccalltest.${SHLIB_EXT} ccalltest

.PHONY: $(TESTS) perf benchmark clean

libccalltest.$(SHLIB_EXT): ccalltest.c
	$(CC) $(CFLAGS) $(DEBUGFLAGS) -O3 $< -fPIC -shared -o $@ $(LDFLAGS) -DCC=$(CC)

ccalltest: ccalltest.c
	$(CC) $(CFLAGS) $(DEBUGFLAGS) -O3 $< -o $@ $(LDFLAGS) -DCC=$(CC)

=== deps/libuv/Makefile ===
# Copyright Joyent, Inc. and other Node contributors. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.

uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

ifdef MSVC
uname_S := MINGW
endif

CPPFLAGS = -Iinclude -Iinclude/uv-private

ifeq (Darwin,$(uname_S))
SOEXT = dylib
else
SOEXT = so
endif

ifneq (,$(findstring MINGW,$(uname_S)))
include config-mingw.mk
else
include config-unix.mk
endif

TESTS=test/blackhole-server.c test/echo-server.c test/test-*.c
BENCHMARKS=test/blackhole-server.c test/echo-server.c test/dns-server.c test/benchmark-*.c

all: libuv.a

test/run-tests$(E): test/run-tests.c test/runner.c $(RUNNER_SRC) $(TESTS) libuv.$(SOEXT)
	$(CC) $(CPPFLAGS) $(RUNNER_CFLAGS) -o $@ $^ $(RUNNER_LIBS) $(RUNNER_LINKFLAGS)

test/run-benchmarks$(E): test/run-benchmarks.c test/runner.c $(RUNNER_SRC) $(BENCHMARKS) libuv.$(SOEXT)
	$(CC) $(CPPFLAGS) $(RUNNER_CFLAGS) -o $@ $^ $(RUNNER_LIBS) $(RUNNER_LINKFLAGS)

test/echo.o: test/echo.c test/echo.h


.PHONY: clean clean-platform distclean distclean-platform test bench


test: test/run-tests$(E)
	$<

bench: test/run-benchmarks$(E)
	$<

clean: clean-platform
	$(RM) -f src/*.o *.a test/run-tests$(E) test/run-benchmarks$(E)

distclean: distclean-platform
	$(RM) -f src/*.o *.a test/run-tests$(E) test/run-benchmarks$(E)

=== src/flisp/Makefile ===
JULIAHOME = $(abspath ../..)
include $(JULIAHOME)/Make.inc

override CFLAGS += $(JCFLAGS)
override CXXFLAGS += $(JCXXFLAGS)

NAME = flisp
EXENAME = $(NAME)
LIBTARGET = lib$(NAME)

SRCS = flisp.c builtins.c string.c equalhash.c table.c iostream.c \
        julia_extensions.c

OBJS = $(SRCS:%.c=%.o)
DOBJS = $(SRCS:%.c=%.do)
LLTDIR = ../support
LLT = $(LLTDIR)/libsupport.a $(BUILD)/lib/libuv.a

FLAGS = -Wall -Wno-strict-aliasing -I$(LLTDIR) $(CFLAGS) \
	-DUSE_COMPUTED_GOTO $(HFILEDIRS:%=-I%) $(LIBDIRS:%=-L%) -fvisibility=hidden
LIBFILES = $(LLT)
LIBS = $(LIBFILES) -lm
ifneq ($(OS),WINNT)
LIBS += -lpthread
endif

DEBUGFLAGS += $(FLAGS)
SHIPFLAGS += $(FLAGS)

default: release

release: $(EXENAME)

debug: $(EXENAME)-debug

HEADERS = $(wildcard *.h) $(JULIAHOME)/deps/libuv/include/uv.h

%.o: %.c $(HEADERS)
	$(QUIET_CC) $(CC) $(CPPFLAGS) $(SHIPFLAGS) -c $< -o $@
%.do: %.c $(HEADERS)
	$(QUIET_CC) $(CC) $(CPPFLAGS) $(DEBUGFLAGS) -c $< -o $@

flisp.o:   flisp.c cvalues.c types.c flisp.h print.c read.c equal.c
flisp.do:  flisp.c cvalues.c types.c flisp.h print.c read.c equal.c
flmain.o:  flmain.c flisp.h
flmain.do: flmain.c flisp.h

$(LLT): $(LLTDIR)/*.h $(LLTDIR)/*.c
	cd $(LLTDIR) && $(MAKE)

$(LIBTARGET)-debug.a: $(DOBJS)
	rm -rf $@
	$(QUIET_LINK) $(AR) -rcs $@ $(DOBJS)
	ln -sf $@ $(LIBTARGET).a

$(LIBTARGET).a: $(OBJS)
	rm -rf $@
	$(QUIET_LINK) $(AR) -rcs $@ $(OBJS)

$(EXENAME)-debug: $(DOBJS) $(LIBFILES) $(LIBTARGET)-debug.a flmain.do
	$(QUIET_CC) $(CC) $(DEBUGFLAGS) $(DOBJS) flmain.do -o $(EXENAME)-debug $(LIBTARGET).a $(LIBS) $(OSLIBS)
	./$(EXENAME)-debug unittest.lsp

$(EXENAME): $(OBJS) $(LIBFILES) $(LIBTARGET).a flmain.o
	$(QUIET_CC) $(CC) $(SHIPFLAGS) $(OBJS) flmain.o $(LDFLAGS) -o $(EXENAME) $(LIBTARGET).a $(LIBS) $(OSLIBS)
	./$(EXENAME) unittest.lsp

clean:
	rm -f *.o
	rm -f *.do
	rm -f *.a
	rm -f $(EXENAME)
	rm -f $(EXENAME)-debug

=== deps/Rmath/src/Makefile ===
include ../Make.inc

SRCS =  bd0.c        dnbeta.c     i1mach.c     pnbinom.c    qlnorm.c     rgeom.c \
	bessel_i.c   dnbinom.c    imax2.c      pnchisq.c    qlogis.c     rhyper.c \
	bessel_j.c   dnchisq.c    imin2.c      pnf.c        qnbeta.c     rlnorm.c \
	bessel_k.c   dnf.c        lbeta.c      pnorm.c      qnbinom.c    rlogis.c \
	bessel_y.c   dnorm.c      lgamma.c     pnt.c        qnchisq.c    rmultinom.c \
	beta.c       dnt.c        lgammacor.c  polygamma.c  qnf.c        rnbinom.c \
	chebyshev.c  dpois.c      log1p.c      ppois.c      qnorm.c      rnchisq.c \
	choose.c     dt.c         mlutils.c    pt.c         qnt.c        rnorm.c \
	d1mach.c     dunif.c      pbeta.c      ptukey.c     qpois.c      rpois.c \
	dbeta.c      dweibull.c   pbinom.c     punif.c      qt.c         rt.c \
	dbinom.c     expm1.c      pcauchy.c    pweibull.c   qtukey.c     runif.c \
	dcauchy.c    fmax2.c      pchisq.c     qbeta.c      qunif.c      rweibull.c \
	dchisq.c     fmin2.c      pexp.c       qbinom.c     qweibull.c \
	dexp.c       fprec.c      pf.c         qcauchy.c    rbeta.c      sign.c \
	df.c         fround.c     pgamma.c     qchisq.c     rbinom.c     signrank.c \
	dgamma.c     fsign.c      pgeom.c      qexp.c       rcauchy.c \
	dgeom.c      ftrunc.c     phyper.c     qf.c         rchisq.c     stirlerr.c \
	dhyper.c     gamma.c      plnorm.c     qgamma.c     rexp.c       toms708.c \
	dlnorm.c     gamma_cody.c plogis.c     qgeom.c      rf.c         wilcox.c \
	dlogis.c     gammalims.c  pnbeta.c     qhyper.c     rgamma.c	

OBJS = $(SRCS:%.c=%.o)
DOBJS = $(SRCS:%.c=%.do)

ifneq ($(MAKECMDGOALS),debug)
XOBJS = $(OBJS)
else
XOBJS = $(DOBJS)
endif

CFLAGS += -DMATHLIB_STANDALONE 

ifeq ($(USE_LIBRANDOM),1)
SRCS += librandom.c
else
SRCS += sunif.c sexp.c snorm.c
endif

default: release

%.o: %.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(fPIC) -std=gnu99 -I../include -DNDEBUG -c $< -o $@
%.do: %.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(fPIC) -std=gnu99 -I../include -g  -c $< -o $@

release debug: libRmath.$(SHLIB_EXT)

libRmath.$(SHLIB_EXT): $(XOBJS)
	rm -rf $@
ifeq ($(USE_LIBRANDOM),1)
	$(CC) $(LDFLAGS) -shared -o $@ $^ -L$(LIBRANDOM_PATH) -lrandom
else
	$(CC) $(LDFLAGS) -shared -o $@ $^ 
endif

clean:
	rm -f *.o *.do *.a *.$(SHLIB_EXT) core* *~ *#

=== debian/changelog ===
julia (0.1+dfsg-1) unstable; urgency=low

  * First upstream release!
  * debian/copyright: document how to recreate orig tarball
  * Add a debian/watch file
  * d/rules, d/p/no-git-patch: adapt for numbered releases.
    In particular, add a COMMITSHA file in the orig tarball containing the
    SHA of the release tag.
  * Promote zlib1g and libarpack2 to Depends
  * Fix typo in manpage

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 14 Feb 2013 12:00:05 +0100

julia (0.1~20130213.git4bc33bbc-1) unstable; urgency=low

  * New upstream release candidate.
    Hopefully obviates the need of ugly hacks in libuv in order to build on
    build daemons.
  * Remove obsolete patches:
     + bump-version-0.1.patch
     + disable-final-uv-loop.patch
     + revert-stdin-file-iostream.patch
  * Refresh other patches

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 13 Feb 2013 10:58:23 +0100

julia (0.1~20130212.gitf375d4bb-1) unstable; urgency=low

  * New upstream snapshot.
  * no-git.patch: simplify and improve patch
  * gsvddense_blasint.patch: remove patch, applied upstream
  * New patches:
    	+ bump-version-0.1.patch
    	+ disable-final-uv-loop.patch
    	+ revert-stdin-file-iostream.patch
  * Refresh other patches

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 12 Feb 2013 12:02:24 +0100

julia (0.1~20130211.git86fbe98d-1) unstable; urgency=low

  * New upstream snapshot.
  * debian/control:
     + add git to Recommends (for Julia package manager)
     + remove dependencies on libglpk-dev (it moved to its own package)
     + add explicit dependency on libgmp10 (there is no more a wrapper)
  * fix-clean-rules.patch: remove patch, applied upstream
  * gsvddense_blasint.patch: new patch
  * Refresh other patches

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 11 Feb 2013 03:51:26 +0100

julia (0.0.0+20130206.git32ff5759-1) unstable; urgency=low

  * New upstream snapshot.
  * debian/copyright: reflect upstream changes
  * debian/rules: update get-orig-source to reflect upstream changes
     + Don't ship nginx
     + Adapt for new configure-random target in deps/Makefile
  * Enable build of Tk wrapper.
     + debian/control: add build dependency on tk-dev
     + debian/rules: add tk rule to build-arch
  * debian/julia.install: install VERSION and COMMIT files
  * no-webrepl.patch: new patch
  * Refresh other patches
  * Add source override for config.status file under deps/random/

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 06 Feb 2013 17:54:29 +0100

julia (0.0.0+20130107.gitd9656f41-2) unstable; urgency=low

  * fix-cpu-detection.patch: do not use -momit-leaf-frame-pointer on non-x86
    archs
  * Upgrade to LLVM 3.2.
     + debian/control: bump build-dependency
     + debian/rules: use llvm-config-3.2
     + debian/patches/use-shared-llvm.patch
       debian/patches/use-sonames-with-dlopen.patch: update patches

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 19 Jan 2013 15:33:43 +0100

julia (0.0.0+20130107.gitd9656f41-1) unstable; urgency=low

  * New upstream snashot
  * No longer try to rebuild helpdb.jl.
     + debian/rules: remove helpdb.jl from build-arch rule
     + debian/control: move back python-sphinx to Build-Depends-Indep
  * debian/copyright: reflect upstream changes
  * Add Build-Conflicts on libatlas3-base (makes linalg tests fail)
  * debian/rules: replace obsolete USE_DEBIAN makeflag by a list of
    USE_SYSTEM_* flags
  * debian/rules: on non-x86 systems, use libm instead of openlibm
  * dpkg-buildflags.patch: remove patch, applied upstream
  * Refreshed other patches

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 16 Jan 2013 12:29:42 +0100

julia (0.0.0+20121214.gitdced1f7-1) unstable; urgency=low

  * New upstream snapshot.
  * debian/copyright: reflect upstream changes
  * Embedded libuv no longer uses libc-ares and libev.
     + debian/control: remove them from build-dependencies
     + debian/rules: no longer strip them from upstream tarball
     + use-system-{ev,c-ares}.patch: remove patches
  * Remove other patches merged upstream or no longer necessary
     + fhs-multiarch.patch
     + linalg-test-tolerance.patch
     + remove-rpath.patch
     + verbose-build.patch
  * New patches
     + do-not-download-patchelf.patch
     + ld-library-path-for-testing.patch
     + dpkg-multiarch.patch
     + libjulia-release-drop-soname.patch
  * Refresh other patches
  * debian/rules:
     + compile with MULTIARCH_INSTALL=1
     + build helpdb.jl as part of the build-arch rule
     + abort on failures in extra tests
  * debian/control: move python-sphinx to Build-Depends (now used in build-arch)

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 18 Dec 2012 14:42:23 +0100

julia (0.0.0+20121102.git63e93f2-1) unstable; urgency=low

  * Initial release. (Closes: #691912)

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 02 Nov 2012 16:29:29 +0100

=== debian/control ===
Source: julia
Priority: extra
Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1~), debhelper (>= 9), dh-exec, llvm-3.2-dev,
 libdouble-conversion-dev, libsuitesparse-dev, gfortran,
 libgmp-dev, libreadline6-dev, libunwind8-dev, libfftw3-dev, libpcre3-dev,
 libarpack2-dev, libncurses5-dev, tk-dev
Build-Depends-Indep: python-sphinx, texlive-latex-extra,
 texlive-fonts-recommended
Build-Conflicts: libatlas3-base
Standards-Version: 3.9.4
Section: science
Homepage: http://julialang.org
Vcs-Git: git://git.debian.org/git/pkg-julia/julia.git
Vcs-Browser: http://git.debian.org/?p=pkg-julia/julia.git

Package: julia
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
# NB: several shared libs have to be hardcoded because they are dlopen'd from
# Julia scripts, and therefore dpkg-shlibdeps cannot detect them
Depends: ${shlibs:Depends}, ${misc:Depends},
 libopenblas-base | libblas3 | libatlas3-base,
 liblapack3 | libatlas3-base, libpcre3, libfftw3-3, libcholmod1.7.1,
 libumfpack5.4.0, libgmp10, zlib1g, libarpack2
Recommends: git
Suggests: julia-doc, ess (>= 12.09-1~)
Description: high-performance programming language for technical computing
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package provides a complete Julia installation (JIT compiler, standard
 library, text-based user interface).

Package: julia-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-jquery, libjs-underscore
Suggests: julia
Description: high-performance programming language for technical computing (documentation)
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package contains the Julia manual, which describes the language and its
 standard library. It also contains example Julia programs.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

COMMON_FLAGS = USE_SYSTEM_LLVM=1 USE_SYSTEM_LIGHTTPD=1 USE_SYSTEM_LIBUNWIND=1 \
	USE_SYSTEM_READLINE=1 USE_SYSTEM_PCRE=1 USE_SYSTEM_BLAS=1 USE_SYSTEM_LAPACK=1 \
	USE_SYSTEM_FFTW=1 USE_SYSTEM_GMP=1 USE_SYSTEM_ARPACK=1 USE_SYSTEM_SUITESPARSE=1 \
	USE_SYSTEM_ZLIB=1 \
	USE_QUIET=0 LLVM_CONFIG=/usr/bin/llvm-config-3.2 MULTIARCH_INSTALL=1

# Openlibm does not compile on non-x86 archs
ifeq (,$(findstring $(DEB_HOST_ARCH_CPU),i386 amd64))
COMMON_FLAGS += USE_SYSTEM_LIBM=1
endif

%:
	dh $@ --parallel

override_dh_auto_build-arch:
	make $(COMMON_FLAGS) all tk

override_dh_auto_build-indep:
	make -C doc latexpdf html

override_dh_auto_test-arch:
	make -C test $(COMMON_FLAGS) default
	make -C test $(COMMON_FLAGS) extra

override_dh_auto_test-indep:

override_dh_auto_clean:
	make $(COMMON_FLAGS) cleanall
	make -C deps $(COMMON_FLAGS) cleanall
	make -C doc cleanall
	rm -rf usr

override_dh_auto_install-arch:
	make $(COMMON_FLAGS) PREFIX=debian/tmp/usr install
	rm -rf usr # Otherwise dh_install does not see debian/tmp/usr

override_dh_auto_install-indep:

get-orig-source:
	git clone https://github.com/JuliaLang/julia.git julia-$(DEB_VERSION_UPSTREAM)
	# Checkout right commit and submodules, download and patch dSFMT,
	# remove unneeded and non DFSG-free sources
	cd julia-$(DEB_VERSION_UPSTREAM) && \
		git checkout v`echo $(DEB_VERSION_UPSTREAM) | sed 's/\+dfsg\d*//'` && \
		git rev-parse --short HEAD > COMMITSHA && \
		git submodule update --init && \
		make -C	deps configure-random && \
		rm -rf deps/random/dsfmt-*.tar.gz \
		       deps/openlibm/test/ieeetestnew.c \
		       deps/openlibm/i387/osx_asm.h \
		       deps/random/dsfmt-*/html/jquery.js \
		       deps/nginx \
		       ui/website/jquery.js
	tar --exclude-vcs -caf julia_$(DEB_VERSION_UPSTREAM).orig.tar.xz julia-$(DEB_VERSION_UPSTREAM)
	rm -rf julia-$(DEB_VERSION_UPSTREAM)
